<template>
  <div
    class="ob-radio-container radio-wrapper"
    :class="{
      disabled: disabled,
      readonly: readonly,
      checked: modelValue === valueInput
    }"
  >
    <label>
      <input
        data-attr="ob-radio-container"
        type="radio"
        :checked="modelValue === valueInput"
        :value="valueInput"
        :disabled="disabled"
        :tabindex="disabled ? -1 : 0"
        :data-qa="dataQa"
        @change="$emit('change', valueInput)"
      >
      <div
        v-if="!hideRadioControl"
        class="input-visual"
      />
      <span v-html="label" />

      <ob-tooltip
        v-if="tooltip"
        :content="tooltip"
        :disabled="disabled"
        :open-delay="500"
        position="top-end"
      >
        <i class="icon question" />
      </ob-tooltip>
    </label>
  </div>
</template>
<script>
import ObTooltip from './../../obComponents/obTooltip'

export default {
  name: 'ObRadio',
  components: { ObTooltip },
  model: {
    prop: 'modelValue',
    event: 'change'
  },
  props: {
    valueInput: {
      type: [String, Number, Boolean],
      required: true
    },
    modelValue: {
      type: [String, Number, Boolean],
      default: () => ''
    },
    label: {
      type: String,
      default: () => ''
    },
    tooltip: {
      type: String,
      default: () => ''
    },
    disabled: {
      type: Boolean,
      default: () => false
    },
    readonly: {
      type: Boolean,
      default: () => false
    },
    hideRadioControl: {
      type: Boolean,
      default: () => false
    },
    dataQa: {
      type: String
    }
  }
}
</script>
<style lang="scss" scoped>
  $transition-timing: .2s cubic-bezier(.645,.045,.355,1);

  .ob-radio-container{
    &.radio-wrapper {
      user-select: none;
      -webkit-user-select: none;
      &.disabled {
        pointer-events: none;
        $disabled-color: $color-grey-border;
        label {
          color: $disabled-color;
        }
        .input-visual {
          border-color: $disabled-color;
          &::after {
            background: $disabled-color;
          }
        }
        .icon.question {
          color: $color-grey-border;
        }
      }
      &.readonly {
        pointer-events: none;
        $disabled-color: $color-grey-label;
        &:not(.checked) {
          label {
            color: $color-grey-label;
          }
          .input-visual {
            border-color: $disabled-color;
            &::after {
              background: $disabled-color;
            }
          }
          .icon.question {
            color: $color-grey-border;
          }
        }
      }
    }
    label {
      display: flex;
      align-items: flex-start;
      font-family: "Roboto", sans-serif;
      font-size: 14px;
      line-height: 20px;
      letter-spacing: 0.2px;
      color: $color-text-base;
      cursor: pointer;
      transition: $transition-timing;
      &:hover .input-visual {
        background: $lavender;
        border-color: $color-blue-navy-blue;
      }
    }
    input {
      margin: 0;
      padding: 0;
      width: 0;
      height: 0;
      opacity: 0;
      background: transparent;
      position: absolute;
      &:checked + .input-visual {
        background: transparent;
        border-color: $color-blue-navy-blue;
        &::after {
          opacity: 1;
        }
      }
      &:focus + .input-visual {
        background: $lavender;
        border-color: $color-blue-navy-blue;
      }
    }
    .input-visual {
      margin-right: 8px;
      width: 16px;
      height: 16px;
      box-sizing: border-box;
      border: 2px solid $color-grey-span;
      border-radius: 50%;
      transition: $transition-timing;
      position: relative;
      top: 2px;
      flex: none;

      &::after {
        content: '';
        position: absolute;
        transition: $transition-timing;
        opacity: 0;
        background: $color-blue-navy-blue;
        height: 8px;
        width: 8px;
        border-radius: 50%;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        margin: auto;
      }
    }
    .icon.question {
      color: $color-blue-navy-blue;
      font-size: 12px;
      line-height: 20px;
      margin-left: 6px;
    }
  }
</style>
